#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
#endregion

namespace Boids {

	public class BoidsGame : Microsoft.Xna.Framework.Game {
		readonly GraphicsDeviceManager graphics;
		readonly ContentManager content;
		readonly BoidsComponent boidsComponent;
		readonly BoidsVisual visual;
		readonly Boids boids = new Boids();

		public BoidsGame() {
			//this.IsFixedTimeStep = false;
			this.TargetElapsedTime = TimeSpan.FromMilliseconds(8);
			graphics = new GraphicsDeviceManager(this);
			graphics.SynchronizeWithVerticalRetrace = false;
			content = new ContentManager(Services);
			Components.Add(visual = new BoidsVisual(this, content, boids));
			Components.Add(boidsComponent = new BoidsComponent(this, boids));
			Random random = new Random();
			for (int i = 0; i < 100; i++) {
				boids.boids.Add(new Boid(boids, new Vector3(
					(float)random.NextDouble() * 10.0f - 5.0f,
					(float)random.NextDouble() * 10.0f - 5.0f,
					(float)random.NextDouble() * 10.0f - 5.0f
					)));
			}
		}

		protected override void Initialize() {
			base.Initialize();
		}

		protected override void LoadGraphicsContent(bool loadAllContent) {
			if (loadAllContent) {
			}
		}

		protected override void UnloadGraphicsContent(bool unloadAllContent) {
			if (unloadAllContent) {
				content.Unload();
			}
		}

		protected override void Update(GameTime gameTime) {
			if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
				this.Exit();
			base.Update(gameTime);
		}

		protected override void Draw(GameTime gameTime) {
			graphics.GraphicsDevice.Clear(Color.SlateBlue);
			base.Draw(gameTime);
		}
	}
}
